package ovgu.dbse.pinnecke;

import ovgu.dbse.pinnecke.qdbs.*;

public class LeftOnly extends BinaryOperator {

    private boolean leftHasNext;

    public LeftOnly(Operator left, Operator right) {
        super(left, right);
        Schemas.equalOrThrow(left.getSchema(), right.getSchema());
    }

    @Override
    public boolean hasNext() {
        leftHasNext = left.hasNext();
        if (leftHasNext) {
            return true;
        }  else {
            return false;
        }
    }

    @Override
    public Schema getSchema() {
        return left.getSchema();
    }

    @Override
    public Record next() {
        return super.left.next();
    }
}
