package ovgu.dbse.pinnecke;

import ovgu.dbse.pinnecke.dbs1.Database;
import ovgu.dbse.pinnecke.qdbs.Operator;
import ovgu.dbse.pinnecke.qdbs.PrettyPrinter;
import ovgu.dbse.pinnecke.qdbs.Table;
import ovgu.dbse.pinnecke.qdbs.operators.*;

public class Main {

    public static void main(String[] args) throws Exception {

        Table haendlerTable = Database.loadHaendlerTable();
        Table kundenTable = Database.loadKundenTable();

        Operator left = new Projection(haendlerTable.fullScan(), "Name");
        Operator right = new Projection(kundenTable.fullScan(), "Name");

        // ---------------------------------------------------------------------------
        //  Example: left-only query
        // ---------------------------------------------------------------------------
        {
            Operator combine = new LeftOnly(left, right);

            new PrettyPrinter(combine).print(System.out);
        }

        // ---------------------------------------------------------------------------
        //  Example: right-only query
        // ---------------------------------------------------------------------------
        {
            Operator combine = new RightOnly(left, right);

            new PrettyPrinter(combine).print(System.out);
        }

        // ---------------------------------------------------------------------------
        //  Task 5.1: union of left and right query
        // ---------------------------------------------------------------------------
        {
            Operator combine = new MyUnion(left, right);

            new PrettyPrinter(combine).print(System.out);
        }

    }
}
